import 'package:flutter/material.dart';
import 'package:hqsoft_core/data_base/data_base.dart';

import 'timeline_element.dart';

class TimelineComponent extends StatefulWidget {
  final List<TimelineModel>? timelineList;

  final Color? lineColor;

  final Color? backgroundColor;

  final Color headingColor;

  final Color descriptionColor;

  final bool? isScroll;

  const TimelineComponent(
      {
      this.timelineList,
      this.lineColor,
      this.backgroundColor,
      required this.headingColor,
      required this.descriptionColor,
      this.isScroll})
     ;

  @override
  TimelineComponentState createState() {
    return new TimelineComponentState();
  }
}

class TimelineComponentState extends State<TimelineComponent>
    with SingleTickerProviderStateMixin {
  Animation<double>? animation;
  late AnimationController controller;
  double fraction = 0.0;

  @override
  void initState() {
    super.initState();
    controller = AnimationController(
        duration: const Duration(milliseconds: 1000), vsync: this);
    controller!.forward();

    // ignore: unnecessary_statements
    widget.isScroll == true;
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      child: ListView.builder(
        physics: widget.isScroll == true
            ? const ScrollPhysics()
            : const NeverScrollableScrollPhysics(),
        itemCount: widget.timelineList?.length,
        itemBuilder: (_, index) {

          return TimelineElement(
            lineColor: widget.lineColor?? Theme.of(context).accentColor ,
            backgroundColor: widget.backgroundColor ?? Colors.white ,
            model: widget.timelineList![index],
            firstElement: index == 0,
            lastElement: widget.timelineList!.length == index + 1,
            controller: controller,
            headingColor: widget.headingColor,
            descriptionColor: widget.descriptionColor,
          );
        },
      ),
    );
  }

  @override
  void dispose() {
    controller.dispose();
    super.dispose();
  }
}
